# detection cloud service


# service pipeline  (CloudLambda.lambda_handler) 
  - Download Satelite imagens
  - get window form the Satelite imagens nad save a RGB .tif file
  - Read the image and aply the windows
   - return the model results

# source description
   CloudLambda -> implements the labda function
   Predic   -> load the model and call the prediction for each satellite
   ProcessaLandSat  -> precesses landsat prediction
   ProcessaSentinel  -> precesses sentinel prediction 


# deploy

## create function packet (service source code )
  - run amazon/create_package

## deploy Layers 
   ### 1 Rasteiro Layer (Layer with the Rasteiro library )  (https://github.com/developmentseed/geolambda)    
      aws lambda publish-layer-version --layer-name rasterio-lambda-layer --description "rasterio-lambda-layer" --zip-file fileb://layers/rasteiro.zip

   ### 2 pytorch Layer
      Neste ponto que estou bloqueado nao consegui um pacote menor que 69M

# deploy function (falta add pytorch Layer )
  aws lambda create-function --function-name cloud-predic --runtime python3.8 --role arn:aws:iam::587023234711:role/service-role/teste-role-nbup20ys --handler CloudLambda.lambda_handler --zip-file fileb://amazon/package.zip --timeout 900 --layers arn:aws:lambda:us-east-2:587023234711:layer:rasterio-lambda-layer:1  
  
# APi Call
    payload ={'product_id': product_id,
             'url': url,
             'satelite': 'satelite', # ('sentinel','landsat' )
             'polygon_wkt': polygon_wkt }
  
    aws lambda invoke --function-name cloud-predic --cli-binary-format raw-in-base64-out --payload payload response.json







   
   


